MKNODAT(2)

NAME
mknodat - create a special or ordinary file relative to a directory file descriptor

SYNOPSIS
#include <fcntl.h> /* Definition of AT_* constants */
#include <sys/stat.h>

int mknodat(int dirfd, const char *pathname, mode_t mode, dev_t dev);

Feature Test Macro Requirements for glibc (see feature_test_macros(7)):

mknodat():
    Since glibc 2.10:
         _XOPEN_SOURCE >= 700
    Before glibc 2.10:
        _ATFILE_SOURCE

DESCRIPTION
The mknodat() system call operates in exactly the same way as mknod(2), except for the differences described in this manual page. If the pathname given in pathname is relative, then it is interpreted relative to the directory referred to by the file descriptor dirfd (rather than relative to the current working directory of the calling process, as is done by mknod(2) for a relative pathname). If pathname is relative and dirfd is the special value AT_FDCWD, then pathname is interpreted relative to the current working directory of the calling process (like mknod(2)). If pathname is absolute, then dirfd is ignored.

RETURN VALUE
On success, mknodat() returns 0. On error, -1 is returned and errno is set to indicate the error.

ERRORS
The same errors that occur for mknod(2) can also occur for mknodat(). The following additional errors can occur for mknodat():

EBADF
    dirfd is not a valid file descriptor.

ENOTDIR
    pathname is relative and dirfd is a file descriptor referring to a file other than a directory.

VERSIONS
mknodat() was added to Linux in kernel 2.6.16.

CONFORMING TO
POSIX.1-2008.

NOTES
See openat(2) for an explanation of the need for mknodat().

SEE ALSO
mknod(2), openat(2), path_resolution(7)

COLOPHON
This page is part of release 3.38 of the Linux man-pages project. A description of the project, and information about reporting bugs, can be found at http://www.kernel.org/doc/man-pages/.